#include "fff.h"

#include <stdlib.h>
#include <stdio.h>

void fff_error( char* fn, char* message, int errcode )
{
  fprintf( stderr, "ERROR (%s): ", fn ); 
  fprintf( stderr, message ); 
  fprintf( stderr, " (errno: %d).\n", errcode ); 
  exit(0); 
  return;
}

void fff_warning( char* fn, char* message )
{
  fprintf( stderr, "WARNING (%s): %s.\n", fn, message ); 
  return; 
}


fff_datatype fff_get_datatype( unsigned int sizeType, 
			       unsigned int integerType, 
			       unsigned int signedType )
{
  fff_datatype type = FFF_UNKNOWN_TYPE; 

  /* Case: integer type */ 
  if ( integerType ) {

    if ( signedType ) {
      if ( sizeType == sizeof(signed char) ) 
	type = FFF_SCHAR;
      else if ( sizeType == sizeof(signed short) )
	type = FFF_SSHORT;
      else if ( sizeType == sizeof(int) )
	type = FFF_INT;
      else if ( sizeType == sizeof(signed long int) )
	type = FFF_LONG;
    }
    else {
      if ( sizeType == sizeof(unsigned char) ) 
	type = FFF_UCHAR;
      else if ( sizeType == sizeof(unsigned short) )
	type = FFF_USHORT;
      else if ( sizeType == sizeof(unsigned int) )
	type = FFF_UINT;
      else if ( sizeType == sizeof(unsigned long int) )
	type = FFF_ULONG;
    }
  
  }
  
  /* Case: floating type */ 
  else {
    if ( sizeType == sizeof(float) ) 
      type = FFF_FLOAT;
    else if ( sizeType == sizeof(double) )
      type = FFF_DOUBLE;
  }

  return type; 

}

