#include "fff_gen_stats.h"
#include "fff_lapack.h"

#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <errno.h>

#if 0 

extern void fff_rng_draw_noreplace(size_t* x, unsigned int n, unsigned int N)
{ 
  fff_vector* rseq = fff_vector_new(N);
  unsigned int i; 

  gsl_rng_env_setup();
  gsl_rng * r = gsl_rng_alloc (gsl_rng_default);
  
  for (i=0 ; i<N ; i++) 
    rseq->data[i] = gsl_rng_uniform(r); 
  
  gsl_rng_free (r);

  gsl_permutation * idx = gsl_permutation_alloc(N);
  gsl_sort_vector_index (idx, rseq);
  
  for (i=0 ; i<n ; i++)
    x[i] = idx->data[i]; 
  
  fff_vector_delete(rseq); 
  gsl_permutation_free(idx);
  return; 
}

#endif 


/* 
   Squared mahalanobis distance: d2 = x' S^-1 x 
   Beware: x is not const
*/ 
extern double fff_mahalanobis( fff_vector* x, fff_matrix* S, fff_matrix* Saux  )
{
  double d2; 
  double m = 0.0; 

  /* Cholesky decomposition: S = L L^t, L lower triangular */
  fff_lapack_dpotrf(CblasLower, S, Saux); 

  /* Compute S^-1 x */ 		 
  fff_blas_dtrsv(CblasLower, CblasNoTrans, CblasNonUnit, S, x); /* L^-1 x */ 
  
  /* Compute x' S^-1 x */ 
  d2 = (double) ( fff_vector_ssd(x, &m, 1) / (long double)x->size ); 

  return d2; 
}

