#include "fff_blas.h"

#include<stdio.h>

int main (int argc, char* argv[])
{
  fff_vector* x = fff_vector_new(2); 
  fff_vector* y = fff_vector_new(2); 
  fff_matrix* A = fff_matrix_new(2,2); 
  int status; 

  x->data[0]=1; x->data[1]=2; 
  y->data[0]=0; y->data[1]=0; 
  A->data[0]=1; A->data[1]=2; A->data[2]=3; A->data[3]=4;  

  status = fff_blas_dgemv (CblasNoTrans, 1.0, A, x, 0.0, y); 
  fprintf(stderr,"No transposition. status=%d\n", status); 
  fprintf(stderr,"y=[%f %f]\n", y->data[0], y->data[1]); 

  status = fff_blas_dgemv (CblasTrans, 1.0, A, x, 0.0, y); 
  fprintf(stderr,"Transposition. status=%d\n", status); 
  fprintf(stderr,"y=[%f %f]\n", y->data[0], y->data[1]); 

  fff_vector_delete(x); 
  fff_vector_delete(y);
  fff_matrix_delete(A); 

  return 0;
}
