#!/usr/bin/env python
"""Simple minimal example calling fff.

ToPort:

- fff.misc.quantile
- fff.mfx.routines.test_stat
"""
#-----------------------------------------------------------------------------
# Imports
#-----------------------------------------------------------------------------

# From the standard library
import os

# Third party imports
import numpy as np

# Imports from the fff project itself
from fff.misc import quantile

#import fff.mfx as MFX

#-----------------------------------------------------------------------------
# Main code begins
#-----------------------------------------------------------------------------

# Get group data
data = np.load(os.path.join('data','offset_002.npz'))
MAT, VAR, XYZ = data.f.mat, data.f.var, data.f.xyz

# Compute Student statistical map and permute sample signs (exhaustively if
# nsubjects <= 10)
nsimu = min( 2**10, 2**MAT.shape[0] )

# XXX - deactivate the MFX call first, just to test that quantile executes at
# all from fff2.
#T = MFX.routines.test_stat( MAT, stat=MFX.routines.student, nsimu=nsimu )

# Fake T, just to check that quantile runs.
T = np.array(XYZ)

# Compute single threshold to control the false positive rate at .01
Tth = quantile( T.ravel(), ratio = 1-1e-2 ) ## flatten to have a stationary
                                            ## threshold

# Compute the Tmax stat for each permutation 
Tmax = T.max(1) 
