T = fffMat_onesample_stat( E, V, flagStat, base, nsimu, magic, niter )

%FFFMAT_ONESAMPLE_STAT - Generic nonparametric RFX test for the mean or median effect. 
%
%  SYNTAX: T = FFFMAT_ONESAMPLE_STAT( E, V, flagSTAT, [BASE, NSIMU, MAGIC, NITER] );
%
%  E: matrix of estimated effects (assumed Nsubjects x Nvoxels)
%
%  V: matrix of first-level variances, same size as Y. It is 
%  taken into account by MFX stats only; for non-MFX stats, 
%  just input anything (e.g. the scalar 0). 
%
%  flagSTAT: 
%      0 (Sample mean)
%      1 (Sample median)
%      2 (Student T, DEFAULT)
%      3 (Laplace T)
%      4 (Tukey T)
%      5 (Sign statistic)
%      6 (Wilcoxon signed rank statistic)
%      7 (Empirical T)
%      8 (Empirical median-based T, aka sign statistic)
%     10 (MFX corrected mean)
%     11 (MFX corrected median) 
%     12 (MFX corrected Student T)
%     17 (MFX corrected empirical T) 
%     18 (MFX corrected sign statistic) 
%
%  BASE: tested baseline value (DEFAULT = 0) 
%
%  NSIMU: number of sign permutations / bootstraps (DEFAULT = 1024). 
%  For permutations, when this number is 2^Nsubjects (or higher), 
%  all possible permutations are generated. 
%
% MAGIC < 0    ==> randomize permutations
% MAGIC >= 0   ==> produce deterministic permutations in the range [magic, magic+nsimu[
%
% NITER: maximal iteration number of (Gaussian) EM algorithm used to identify
% parameters in MFX analyses
%
%  T: returned vector of statistics  
% 

%  Copyright (C) 2006 Alexis Roche
%  $Revision: 1.6 $Date: 2006/07/27 $

error(sprintf('Missing MEX-file: %s', mfilename));
%magic < 0    ==> randomize permutations
%magic >= 0   ==> produce deterministic permutations in the range [magic, magic+nsimu[
