static PyObject* call_blas3(PyObject* self, PyObject* args)
{
	PyArrayObject *py_A, *py_B, *py_res;
	fff_matrix *A, *B, *C; 
	fff_vector *res;
	double alpha, beta; 

	/* Check that input object is an array */
	if (!PyArg_ParseTuple(args, "O!O!dd:call_blas2", 
			      &PyArray_Type, &py_A, 
			      &PyArray_Type, &py_B, 
			      &alpha, &beta))
		Py_RETURN_NONE;

	A = fff_matrix_fromPyArray( py_A );
	B = fff_matrix_fromPyArray( py_B );
	C = fff_matrix_new(A->size1, A->size2);
	fff_vector aux; 	

	res = fff_vector_new(4); 

	/* Tests: dsymm */ 
	fprintf(stderr, "Testing BLAS3: dsymm\n"); 
	fff_blas_dsymm(CblasLeft, CblasUpper, 
		       alpha, A, 
		       B, beta, C); 
	aux = fff_matrix_diag(C); 
	res->data[0] = fff_blas_dasum(&aux);
	fff_blas_dsymm(CblasRight, CblasUpper, 
		       alpha, A, 
		       B, beta, C); 
	aux = fff_matrix_diag(C); 
	res->data[1] = fff_blas_dasum(&aux);
	fff_blas_dsymm(CblasLeft, CblasLower, 
		       alpha, A, 
		       B, beta, C); 
	aux = fff_matrix_diag(C); 
	res->data[2] = fff_blas_dasum(&aux);
	fff_blas_dsymm(CblasRight, CblasLower, 
		       alpha, A, 
		       B, beta, C); 
	aux = fff_matrix_diag(C); 
	res->data[3] = fff_blas_dasum(&aux);

	fff_matrix_delete(C); 
	py_res = fff_vector_toPyArray( res );

	return PyArray_Return( py_res );
}
