static PyObject* pass_array(PyObject* self, PyObject* args)
{
  PyArrayObject *x, *xout;
  int flagCopy = 0; 
  
  /* Check that input object is an array */ 
  if (!PyArg_ParseTuple(args, "O!i:pass_array", &PyArray_Type, &x, &flagCopy)) 
    Py_RETURN_NONE; 
  
  fff_array* y = fff_array_fromPyArray( x );
  
  /* Copy and pass */
  if ( flagCopy ) {
    fff_array* z = fff_array_new(y->datatype, y->dimX, y->dimY, y->dimZ, y->dimT); 
    fff_array_copy( z, y ); 
    xout = fff_array_toPyArray( z );
    fff_array_delete( y ); 
  }
  /* Just pass */ 
  else
    xout = fff_array_toPyArray( y ); 
  
  return PyArray_Return( xout );
}
