static PyObject* pass_matrix(PyObject* self, PyObject* args)
{
  PyArrayObject *x, *xout;
  int flagCopy = 0; 
  
  /* Check that input object is an array */ 
  if (!PyArg_ParseTuple(args, "O!i:pass_matrix", &PyArray_Type, &x, &flagCopy)) 
    Py_RETURN_NONE; 
  
  fff_matrix* y = fff_matrix_fromPyArray( x );
  
  /* Copy and pass */
  if ( flagCopy ) {
    fff_matrix* z = fff_matrix_new( y->size1, y->size2 ); 
    fff_matrix_memcpy( z, y ); 
    xout = fff_matrix_toPyArray( z );
    fff_matrix_delete( y ); 
  }
  /* Just pass */ 
  else
    xout = fff_matrix_toPyArray( y ); 
  
  return PyArray_Return( xout );
}
