static PyObject* pass_vector(PyObject* self, PyObject* args)
{
	PyArrayObject *x, *xout;
	int flagCopy = 0;

	/* Check that input object is an array */
	if (!PyArg_ParseTuple(args, "O!i:pass_vector", &PyArray_Type, &x, &flagCopy))
		Py_RETURN_NONE;

	fff_vector* y = fff_vector_fromPyArray( x );
	
	/* Copy and pass */
	if ( flagCopy ) {
		fff_vector* z = fff_vector_new( y->size );
		fff_vector_memcpy( z, y );
		xout = fff_vector_toPyArray( z );
		fff_vector_delete( y );
	}
	/* Just pass */
	else
		xout = fff_vector_toPyArray( y );

	return PyArray_Return( xout );
}
