#include <fffpy.h>
#define PY_ARRAY_UNIQUE_SYMBOL PyArray_API

static char pass_vector_doc[] = " pass_vector(array, flagCopy) : pass a vector through a ref or a copy";
static char pass_matrix_doc[] = " pass_matrix(array, flagCopy) : pass a matrix through a ref or a copy";
static char pass_array_doc[] = " pass_array(array, flagCopy) : pass an array through a ref or a copy";
static char call_blas1_doc[] = " call_blas1(x, y, alpha) : test BLAS Level 1 routines";
static char call_blas2_doc[] = " call_blas2(A, x, y, alpha, beta) : test BLAS Level 2 routines";
static char call_blas3_doc[] = " call_blas3(A, B, alpha, beta) : test BLAS Level 3 routines";

#include <fff_blas.h>
#include "pass_vector.c"
#include "pass_matrix.c"
#include "pass_array.c"
#include "call_blas1.c"
#include "call_blas2.c"
#include "call_blas3.c"


static PyMethodDef module_methods[] = {
	{"pass_vector", pass_vector, METH_VARARGS, pass_vector_doc},
	{"pass_matrix", pass_matrix, METH_VARARGS, pass_matrix_doc},
	{"pass_array", pass_array, METH_VARARGS, pass_array_doc},
	{"call_blas1", call_blas1, METH_VARARGS, call_blas1_doc},
	{"call_blas2", call_blas2, METH_VARARGS, call_blas2_doc},
	{"call_blas3", call_blas3, METH_VARARGS, call_blas3_doc},
	{NULL, NULL}
};

static char module_doc[] = "fff C/numpy testing functions";

void inittestmodule(void)
{
  Py_InitModule3("testmodule", module_methods, module_doc);
  fffpy_import_array(); 
  import_array();   /* required NumPy initialization */
}
