#!/usr/bin/env python

from numpy.testing import *
from numpy import *
from numpy.random import rand, randint
import fff2.bindings as fb
import weakref
import sys
import os

""" Test standard bindings """
class test_everything(NumpyTestCase):

    def check_vector_get(self):
        x = rand(10)
        i = randint(10)
        xi = fb.vector_get(x, i)
        assert_equal(xi, x[i])

    def check_vector_get2(self):
        x = (100*rand(10)).astype('int32')
        i = randint(10)
        xi = fb.vector_get(x, i)
        assert_equal(xi, x[i])

    def check_vector_set(self):
        x = rand(10)
        i = randint(10)
        y = fb.vector_set(x, i, 3)
        assert_equal(3, y[i])

    def check_vector_set2(self):
        x = (100*rand(10)).astype('int32')
        i = randint(10)
        y = fb.vector_set(x, i, 3)
        assert_equal(3, y[i])

    """
    def check_blas1(self):
        x = rand(10)
        y = rand(10)
        x0 = x
        y0 = y
        a = double(rand(1))
        x = x + y
        x = x * y
        y = y - x
        y = y / x
        r = zeros(8)
        r[0] = dot(x,y)
        r[1] = sqrt(sum(x**2))
        r[2] = sum(abs(x))
        r[3] = x.argmax()
        y = a*x + y
        r[4] = sqrt(sum(y**2))
        x = a*x
        r[5] = sum(abs(x))
        xc = x
        x = y
        y = xc
        r[6] = sum(abs(x))
        r[7] = 0
        rf = fb.call_blas1(x0,y0,a)
        assert_almost_equal(r, rf)

        
    def check_blas2(self):
        x = rand(10)
        y = rand(10)
        A = rand(10,10)
        a = double(rand(1))
        b = double(rand(1))
        x0 = x
        y0 = y
        r = zeros(12)
        # dgemv
        y = a*dot(A, x) + b*y
        r[0] = sum(abs(y))
        y = a*dot(A.transpose(), x) + b*y
        r[1] = sum(abs(y))
        # dtrmv
        U = tril(A.transpose()).transpose()
        L = tril(A)
        Ld = L.copy()
        Ld[range(10),range(10)] = 1
        x = dot(U,x)
        r[2] = sum(abs(x))
        x = dot(U.transpose(),x)
        r[3] = sum(abs(x))
        y = dot(L, y)
        r[4] = sum(abs(y))
        y = dot(Ld.transpose(), y)
        r[5] = sum(abs(y))
        # dtrsv
        x = dot(linalg.inv(U), x)
        r[6] = sum(abs(x))
        x = dot(linalg.inv(U.transpose()), x)
        r[7] = sum(abs(x))
        y = dot(linalg.inv(L.transpose()), y)
        r[8] = sum(abs(y))
        y = dot(linalg.inv(Ld), y)
        r[9] = sum(abs(y))
        # dsymv
        Asym = U + U.transpose() - diag(U.diagonal())
        y = a*dot(Asym, x) + b*y
        r[10] = sum(abs(y))
        Asym = L + L.transpose() - diag(L.diagonal())
        y = a*dot(Asym, x) + b*y
        r[11] = sum(abs(y))
        
        rf = fb.call_blas2(A,x0,y0,a,b)
        assert_almost_equal(r, rf)


    def check_blas3(self):
        A = rand(10,10)
        B = rand(10,10)
        a = double(rand(1))
        b = double(rand(1))
        r = zeros(4)

        U = tril(A.transpose()).transpose()
        Aup = U + U.transpose() - diag(U.diagonal())
        L = tril(A)
        Alo = L + L.transpose() - diag(L.diagonal())

        C = zeros([10,10])
        C = a * dot(Aup, B) + b * C
        r[0] = sum(abs(C.diagonal()))
        C = a * dot(B, Aup) + b * C
        r[1] = sum(abs(C.diagonal()))
        C = a * dot(Alo, B) + b * C
        r[2] = sum(abs(C.diagonal()))
        C = a * dot(B, Alo) + b * C
        r[3] = sum(abs(C.diagonal()))
        rf = fb.call_blas3(A,B,a,b)
        assert_almost_equal(r, rf)
    """
   
    def check_refcounts(self):
        pass



if __name__ == '__main__':
    NumpyTest().run()

