#!/usr/bin/env python

from numpy.testing import *

from numpy.random import rand
from numpy import median, dot
from numpy.linalg import inv
import fff2.misc as fm

class test_quantile(NumpyTestCase):

    def check_median_10(self):
        x = rand(10)
        assert_almost_equal(fm.median(x), median(x))

    def check_median_11(self):
        x = rand(11)
        assert_equal(fm.median(x), median(x))

    def check_median_1000(self):
        x = rand(1000)
        assert_almost_equal(fm.median(x), median(x))

    def check_median_1001(self):
        x = rand(1000)
        assert_equal(fm.median(x), median(x))

    def check_mahalanobis(self):
        x = rand(100)
        A = rand(100,100)
        A = dot(A.transpose(), A)
        mah = dot(x, dot(inv(A), x))
        assert_almost_equal(mah, fm.mahalanobis(x, A)) 
        


if __name__ == "__main__":
    NumpyTest().run()
