#!/usr/bin/env python

def configuration(parent_package='',top_path=None):

    from numpy.distutils.misc_util import Configuration
    from glob import glob
    from os.path import join, split, splitext, basename

    config = Configuration('fff2', parent_package, top_path)

    config.add_subpackage('bindings')
    config.add_subpackage('misc')
    ##config.add_subpackage('glm')
    ##config.add_subpackage('mfx')
    ##config.add_subpackage('match')
    config.add_data_dir('tests')
    ##config.add_data_dir(join('tests', 'data'))
    
    """
    Add an extension for each C file found in the source directory. 
    """
    root = split(__file__)[0]
    Cfiles = glob(join(root, '*.c'))
    for Cfile in Cfiles:
        name, ext = splitext(basename(Cfile))
        print('Adding extension: %s' % name)
        config.add_extension(
            '_'+name,
            sources=[Cfile],
            libraries=['fffpy']
            )
    
    config.make_config_py() # installs __config__.py

    return config

if __name__ == '__main__':
    print 'This is the wrong setup.py file to run'
