#include "fff_iolib.h"
#include "fff_macro.h"

#include <stdio.h>
#include <stdarg.h>

void fff_message( fff_message_type type, char* fn, char* msg, ... )
{
  char *type_str;
  char *buf_msg = msg; 
  va_list ap;
  int d;
  double f; 
  
  switch ( type ) {
  default:
  case fff_NORMAL_MSG:
    type_str = "";
    break;
  case fff_WARNING_MSG:
    type_str = "WARNING"; 
    break;
  case fff_ERROR_MSG:
    type_str = "ERROR";
    break;
  case fff_DEBUG_MSG:
    type_str = "DEBUG"; 
    break;
  }

#if fff_VERBOSE 

  fprintf( stderr, "(%s) %s: ", fn, type_str ); 

  va_start (ap, msg);
  while ( *buf_msg ) {
    switch ( *buf_msg ) {
    default: 
      fprintf(stderr, "%c", *buf_msg );
      break; 
    case '%': /* special character*/ 
      buf_msg ++; 
      switch ( *buf_msg ) {
      case 'd': /* integer */
	d = va_arg (ap, int);
	fprintf ( stderr, "%d", d );
	break;
      case 'f': /* double */
	f = va_arg (ap, double);
	fprintf ( stderr, "%f", f );
	break;
      }
      break;
    }
    buf_msg ++; 
  }

  /*  fprintf(stderr, "\n"); */
  va_end (ap);

#endif 

  return; 
}
