/*! 
  \file fff_iolib.h
  \brief Input / output functions. 
  \author Alexis Roche
  \date 2004 

  Detailed comments to be added.

  */

#ifndef fff_IOLIB
#define fff_IOLIB

#ifdef __cplusplus
extern "C" {
#endif

  /*!
    \typedef fff_message_type
    \brief Type of message to be printed. 

  */ 
  typedef enum {
    fff_NORMAL_MSG = 0,     /*!< normal message */ 
    fff_WARNING_MSG = 1,    /*!< warning message */  
    fff_ERROR_MSG = 2,      /*!< error message */
    fff_DEBUG_MSG = 3       /*!< debug message */
  } fff_message_type;

  /*! \brief Variadic function to print a message.
      \param type type of message 
      \param fn name of the calling function
      \param msg message text 

      Additional arguments may be from either int or double types.

  */
  extern void fff_message( fff_message_type type, char* fn, char* msg, ... );


#ifdef __cplusplus
}
#endif

#endif
